@use '../core/variables_scss' as v;

/*
 * Note:
 * .-h1,-h2,... are defined near h1,h2,... in "resets/_h.scss"
 */

.-text {
  &--color {
    @each $color, $variants in v.$states {
      @each $variant in $variants {
        &-#{"" + $variant} { color: var(--color-#{"" + $color}) }
        &-#{"" + $variant}-alt { color: var(--color-#{"" + $color}-alt) }
      }
    }

    @each $color in v.$colors {
      &-#{"" + $color} { color: var(--color-#{"" + $color}) }
      &-#{"" + $color}-alt { color: var(--color-#{"" + $color}-alt) }
    }
  }

  @each $weight in v.$weights {
    &--weight-#{"" + $weight} { font-weight: var(--font-weight-#{"" + $weight}) }
  }

  &--center { text-align: center; }
  &--left { text-align: left; }
  &--right { text-align: right; }

  &--smaller { font-size: var(--font-size-smaller); }
  &--small { font-size: var(--font-size-small); }
  &--default-size { font-size: var(--font-size-base); }
  &--medium { font-size: var(--font-size-medium); }
  &--large { font-size: var(--font-size-large); }
  &--xlarge { font-size: var(--font-size-xlarge); }
  &--xxlarge { font-size: var(--font-size-xxlarge); }

  &--monospace { font-family: var(--font-family-monospace); }

  &--nowrap { white-space: pre; }

  &--italic { font-style: italic; }

  &--ellipsis {
    overflow-x: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  &--struck {
    text-decoration: line-through;
  }

  &--ok { background-color: var(--state-color-green); }
  &--bad { background-color: var(--state-color-red); }
}

.-clickable { cursor: pointer; }

.-pre-wrap { white-space: pre-wrap; }
